;-----------------------------------------------------------------------------
; NexGen Nx586 ExtOn/ExtOff utility
;-----------------------------------------------------------------------------
; File: EXT.ASM
; Date: 2006-08-09
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		title "ExtOn/ExtOff NexGen utility"

		.386
		.listall

StackSize       equ 200h

; ASCII character codes
LF              equ 10
CR              equ 13

; special NexGen opcode: API to hypercode
nxop            macro
		db 0fh, 55h
		endm

code_s		segment byte public use16 'CODE'
		assume cs:code_s
		assume ds:text_s, es:text_s, ss:stack_s

		db 10h dup(0)

		public start

start:		push	ds
		push	es
		mov	ax,seg text_s
		mov	ds,ax
		mov	es,ax

	; call hypercode API to get version
		mov	si,0B000h	; function 00h: identification
		nxop			; Returns hypercode version as 4-char
					; string, e.g. 71343330h = "034q"
					; "033" is VL, "034" is PCI system
	; check for "033w"-"033z" (actually, only "033w" exists)
		shr	edx,16		; highword
		cmp	dl,33h		; must be "3" for VL
		jnz	short incorrect
		cmp	dh,'w'		; must be "w"-"z"
		jb	short incorrect
		cmp	dh,'z'
		ja	short incorrect

	; call hypercode API to enable/disable hypercode emulation of
	; the x86 opcodes "MOV reg/mem to/from segreg"
		mov	al,5		; subfunction 05h: "Game assistant"
					; (minor conflict with implementing
					; DOS extenders) (only on VL)
		mov	cl,EXTVAL	; defined on assembler command line:
					; 0 for ExtOff, 1 for ExtOn
		mov	si,0B00Eh	; function 0Eh: misc
		nxop
		jmp	short done

incorrect:	mov	dx,offset TxIncorBios
		mov	ah,9
		int	21h		; DOS -	PRINT STRING DS:DX

done:		pop	es
		pop	ds
		mov	ax,4C00h
		int	21h		; DOS -	EXIT WITH CODE AL=0
code_s		ends


text_s		segment	byte public use16 ''
TxIncorBios	db 'Incorrect BIOS revision, Please contact yor dealer.'
		db CR,LF,'$'
		db CR,LF,'$'		; unused
text_s		ends

stack_s		segment	byte stack 'STACK'
		db StackSize dup(?)
stack_s		ends

		end start

;----------------------------------------------------------------- end EXT.ASM
