; +----------------------------------------------------+
; | BIOS data                                          |
; +----------------------------------------------------+

bdata		segment	use16 at 40h

com_port_1	dw ?		; Base I/O address of 1st serial I/O port
com_port_2	dw ?		; Base I/O address of 2nd serial I/O port
com_port_3	dw ?		; Base I/O address of 3rd serial I/O port
com_port_4	dw ?		; Base I/O address of 4th serial I/O port
prn_port_1	dw ?		; Base I/O address of 1st parallel I/O port
prn_port_2	dw ?		; Base I/O address of 2nd parallel I/O port
prn_port_3	dw ?		; Base I/O address of 3rd parallel I/O port
prn_port_4	dw ?		; Base I/O address of 4th parallel I/O port
equip_bits	dw ?		; Equipment installed info bits
				; 15  14  13   12   11	10   9	 8
				; \    /      game  \	    /
				; # of print  port  # of RS-232
				; ports	0-3   used   ports 0-4
				; 
				; 7   6	   5	4    3	 2   1	 0
				; \   /	   \	/    \	 / Math	 |
				; # of	 video mode  RAM    uP	no
				; dis
manufactr_test	db ?		; Manufacturing	Test Byte
				; bit 0	= 1 while in test mode
				; MCA systems use other	bits
				;   during POST	operations
base_ram_size	dw ?		; Base memory size in KBytes (0-640)
mtest_scratchpad db ?		; [AT] {Manufacturing test scratch pad}
				; [Compaq Deskpro 386] previous	scan code
error_codes	db ?		; [AT] {Manufacturing test scratch pad}
				; [PS/2	Mod 30]	{BIOS control flags}
				; [Compaq Deskpro 386] keyclick	loudness (00h-7Fh)
keybd_flags_1	db ?		; Keyboard flag	bits
				;   7	6   5	4    3	 2   1	 0
				; ins- cap num scrl alt	ctl lef	rig
				; sert --toggles--- --shifts down--
keybd_flags_2	db ?		; Keyboard flag	bits
				;    7	   6	 5     4   
				; insert  caps	num  scroll
				; ------now depressed------
				; 
				;    3	   2	 1     0
				;  pause  sys	left right
				;  lock	request	-alt-down-
keybd_alt_num	db ?		; Alt-nnn keypad workspace
keybd_q_head	dw ?		; pointer to next character in keyboard	buffer
keybd_q_tail	dw ?		; pointer to first free	slot in	keyboard buffer
keybd_queue	dw 10h dup(?)	; Keyboard circular buffer
dsk_recal_stat	db ?		; Recalibrate floppy drive bits
				;    3	     2	     1	     0
				; drive-3 drive-2 drive-1 drive-0
				; 
				; bit 7	= interrupt flag
dsk_motor_stat	db ?		; Motor	running	status & disk write
				;  bit 7=1 disk	write in progress
				;  bits	6&5 = drive selected 0 to 3
				;     3	      2	      1	      0
				;  drive-3 drive-2 drive-1 drive-0
				;  --------- 1=motor on-----------
dsk_motor_timer	db ?		; Motor	timer, at 0, turn off motor
dsk_ret_code	db ?		; Controller return code
				;  00h = ok
				;  01h = bad command or	parameter
				;  02h = can't find address mark
				;  03h = can't write, protected dsk
				;  04h = sector	not found
				;  08h = DMA overrun
				;  09h = DMA attempt over 64K bound
				;  10h = bad CRC on disk read
				;  20h = controller 
dsk_status_1	db ?		; Status bytes-disk controller chip
				;  Note: 7 info	bytes returned from
				;  controller are saved	here. Refer
				;  to the NEC uPD 765 chip manual
				;  for the specific info, depending
				;  on the previous command issued.
dsk_status_2	db ?
dsk_status_3	db ?
dsk_status_4	db ?
dsk_status_5	db ?
dsk_status_6	db ?
dsk_status_7	db ?
video_mode	db ?		; Present display mode
video_columns	dw ?		; Number of columns
video_buf_size	dw ?		; Video	buffer size in bytes
				;   Note: size may be rounded up to
				;   the	nearest	2K boundary.  For
				;   example, 80x25 mode=4000 bytes,
				;   but	value may be 4096.
video_pageoff	dw ?		; Video	page offset of the active
				;   page, from start of	current	
				;   video segment.
vid_curs_pos0	dw ?		; Cursor position page 0
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos1	dw ?		; Cursor position page 1
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos2	dw ?		; Cursor position page 2
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos3	dw ?		; Cursor position page 3
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos4	dw ?		; Cursor position page 4
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos5	dw ?		; Cursor position page 5
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos6	dw ?		; Cursor position page 6
				;   bits 15-8=row, bits	7-0=column
vid_curs_pos7	dw ?		; Cursor position page 7
				;   bits 15-8=row, bits	7-0=column
vid_curs_mode	dw ?		; Active cursor, start & end lines 
				;   bits 12 to 8 for starting line
				;   bits 4  to 0 for ending line
video_page	db ?		; Present page
video_port	dw ?		; Video	controller base	I/O address
video_mode_reg	db ?		; Hardware mode	register bits
video_color	db ?		; Color	set in CGA modes
gen_use_ptr	dw ?		; General use offset pointer
gen_use_seg	dw ?		; General use segment pointer
gen_int_occurd	db ?		; Unused interrupt occurred
				;   value holds	the IRQ	bit 7-0	of
				;   the	interrupt that occurred
timer_low	dw ?		; Timer, low word, cnts every 55 ms
timer_high	dw ?		; Timer, high word
timer_rolled	db ?		; Timer	overflowed, set	to 1 when
				;  more	than 24	hours have elapsed
keybd_break	db ?		; Bit 7	set if break key depressed
warm_boot_flag	dw ?		; Boot (reset) type
				;   1234h=warm boot, no	memory test	  
				;   4321h=boot & save memory
hdsk_status_1	db ?		; Hard disk status
				;  00h = ok
				;  01h = bad command or	parameter
				;  02h = can't find address mark
				;  03h = can't write, protected dsk
				;  04h = sector	not found
				;  05h = reset failure
				;  07h = activity failure
				;  08h = DMA overrun
				;  09h = DMA attempt over 64K bound
				;  0Ah = 
hdsk_count	db ?		; Number of hard disk drives
hdsk_head_ctrl	db ?		; Head control (XT only)
hdsk_ctrl_port	db ?		; Hard disk control port (XT only)
prn_timeout_1	db ?		; Countdown timer waits	for printer
				;   to respond (printer	1)
prn_timeout_2	db ?		; Countdown timer waits	for printer
				;   to respond (printer	2)
prn_timeout_3	db ?		; Countdown timer waits	for printer
				;   to respond (printer	3)
prn_timeout_4	db ?		; Countdown timer waits	for printer
				;   to respond (printer	4)
rs232_timeout_1	db ?		; Countdown timer waits	for RS-232 (1)
rs232_timeout_2	db ?		; Countdown timer waits	for RS-232 (2)
rs232_timeout_3	db ?		; Countdown timer waits	for RS-232 (3)
rs232_timeout_4	db ?		; Countdown timer waits	for RS-232 (4)
keybd_begin	dw ?		; Ptr to beginning of keybd queue
keybd_end	dw ?		; Ptr to end of	keyboard queue
video_rows	db ?		; Rows of characters on	display	- 1
video_pixels	dw ?		; Number of pixels per charactr	* 8
video_options	db ?		; Display adapter options
				;   bit	7 = clear RAM
				;   bits 6,5 = memory on adapter
				;		00 - 64K
				;		01 - 128K
				;		10 - 192K
				;		11 - 256K
				;   bit	4 = unused
				;   bit	3 = 0 if EGA/VGA active
				;   bit	2 = wait for display enable
				;   
video_switches	db ?		; Switch setting bits from adapter
				;   bits 7-4 = feature connector
				;   bits 3-0 = option switches
video_1_save	db ?		; Video	save area 1-EGA/VGA control
				;   bit	7 = 200	line mode
				;   bits 6,5 = unused
				;   bit	4 = 400	line mode
				;   bit	3 = no palette load
				;   bit	2 = mono monitor
				;   bit	1 = gray scale
				;   bit	0 = unused
video_2_save	db ?		; Video	save area 2
dsk_data_rate	db ?		; Last data rate for diskette
				;  bits	7 & 6 =	00 for 500K bit/sec
				;	      =	01 for 300K bit/sec
				;	      =	10 for 250K bit/sec
				;	      =	11 for 1M bit/sec
				;  bits	5 & 4 =	step rateRate at start of operation
				;  bits	3 & 2 =	00 for 500K bit/sec
				;	 
hdsk_status_2	db ?		; Hard disk status
hdsk_error	db ?		; Hard disk error
hdsk_complete	db ?		; When the hard	disk controller's
				;  task	is complete, this byte is
				;  set to FFh (from interrupt 76h)
dsk_options	db ?		; Diskette controller information
				;  bit 6 = 1 Drv 1 type	determined
				;      5 = 1 Drv 1 is multi-rate
				;      4 = 1 Drv 1 change detect
				;      2 = 1 Drv 0 type	determined
				;      1 = 1 Drv 0 is multi-rate
				;      0 = 1 Drv 0 change detect
dsk0_media_st	db ?		; Media	state for diskette drive 0
				;     7	     6	    5	   4
				;  data	xfer rate  two	 media
				;   00=500K bit/s  step	 known
				;   01=300K bit/s
				;   10=250K bit/s
				;   11=1M bit/sec
				;     3	     2	    1	   0
				;  unused  -----state of drive-----
				;	   bits	floppy	driv
dsk1_media_st	db ?		; Media	state for diskette drive 1
				;  (see	dsk0_media_st)
dsk0_start_st	db ?		; Starting state for drive 0
dsk1_start_st	db ?		; Starting state for drive 1
dsk0_cylinder	db ?		; Current track	number for drive 0
dsk1_cylinder	db ?		; Current track	number for drive 1
keybd_flags_3	db ?		; Special keyboard type	and mode
				;  bit 7 Reading ID of keyboard
				;      6 last char is 1st ID char
				;      5 force num lock
				;      4 101/102 key keyboard
				;      3 right alt key down
				;      2 right ctrl key	down
				;      1 E0h hidden code last
				;      0 E1h hidden code last
keybd_flags_4	db ?		; Keyboard Flags (advanced keybd)
				;   7	   6	   5	 4  3 2	1 0
				; xmit	 char	Resend	Ack	 /
				; error	was ID	Rec'd  Rec'd   LEDs
timer_waitoff	dw ?		; Ptr offset to	wait done flag
timer_waitseg	dw ?		; Ptr segment to wait done flag
timer_clk_low	dw ?		; Timer	low word, 1 microsecond	clk
timer_clk_high	dw ?		; Timer	high word. Updated approximately every
				; 55 milliseconds by the BIOS INT 08 handler
timer_clk_flag	db ?		; Timer	flag 00h = post	acknowledgd
				;	     01h = busy
				;	     80h = posted
lan_bytes	db 7 dup(?)	; Local	area network bytes (7)
video_sav_tbl	dd ?		; Pointer to a save table of more
				; pointers for the video system	
				;	     SAVE TABLE
				;  offset type	  pointer to
				;    
				;    0	   dd  Video parameters
				;    4	   dd  Parms save area
				;    8	   dd  Alpha char set
				;   0Ch	   dd  Graphic
		db 22h dup(?)
days_since1_80	dw ?		; Days since 1-Jan-1980	counter

bdata		ends