; +----------------------------------------------------+
; | SCREEN codes                                       |
; +----------------------------------------------------+

; Bits 4-7 determine the character's background color and blink state.
; Bits 0-3 determine the foreground color and brightness.
;
;       7        6        5        4           3        2        1        0
;  +-----------------------------------+ +-----------------------------------+
;  | Blink  |  Red   |  Green |  Blue  | | Bright |  Red   |  Green |  Blue  |
;  +-----------------------------------+ +-----------------------------------+
;
;               Background                              Foreground
;
;  ---------------------------------------------------------------------------
;   -- Bits --    Hex                    | -- Bits --    Hex
;   7  6  5  4   Value    Color          | 3  2  1  0   Value    Color
;  --------------------------------------+------------------------------------
;   0  0  0  0     0      Black          | 0  0  0  0     0      Black
;   0  0  0  1     1      Blue           | 0  0  0  1     1      Blue
;   0  0  1  0     2      Green          | 0  0  1  0     2      Green
;   0  0  1  1     3      Cyan           | 0  0  1  1     3      Cyan
;   0  1  0  0     4      Red            | 0  1  0  0     4      Red
;   0  1  0  1     5      Magenta        | 0  1  0  1     5      Magenta
;   0  1  1  0     6      Brown          | 0  1  1  0     6      Brown
;   0  1  1  1     7      White          | 0  1  1  1     7      White
;   1  0  0  0     8      Black blink    | 1  0  0  0     8      Dark gray
;   1  0  0  1     9      Blue blink     | 1  0  0  1     9      Light blue
;   1  0  1  0     A      Green blink    | 1  0  1  0     A      Light green
;   1  0  1  1     B      Cyan blink     | 1  0  1  1     B      Light cyan
;   1  1  0  0     C      Red blink      | 1  1  0  0     C      Light red
;   1  1  0  1     D      Magenta blink  | 1  1  0  1     D      Light magenta
;   1  1  1  0     E      Brown blink    | 1  1  1  0     E      Yellow
;   1  1  1  1     F      White blink    | 1  1  1  1     F      Bright white
;  ---------------------------------------------------------------------------

BG_Black	equ 00h
BG_Blue		equ 10h
BG_Green	equ 20h
BG_Cyan		equ 30h
BG_Red		equ 40h
BG_Magenta	equ 50h
BG_Brown	equ 60h
BG_White	equ 70h

BG_BlBlack	equ 80h
BG_BlBlue	equ 90h
BG_BlGreen	equ 0A0h
BG_BlCyan	equ 0B0h
BG_BlRed	equ 0C0h
BG_BlMagenta	equ 0D0h
BG_BlBrown	equ 0E0h
BG_BlWhite	equ 0F0h

FG_Black	equ 00h
FG_Blue		equ 01h
FG_Green	equ 02h
FG_Cyan		equ 03h
FG_Red		equ 04h
FG_Magenta	equ 05h
FG_Brown	equ 06h
FG_White	equ 07h

FG_DkGrey	equ 08h
FG_LtBlue	equ 09h
FG_LtGreen	equ 0Ah
FG_LtCyan	equ 0Bh
FG_LtRed	equ 0Ch
FG_LtMagenty	equ 0Dh
FG_Yellow	equ 0Eh
FG_BrWhite	equ 0Fh